import Flutter
import UIKit

public class SwiftFlutter360imageViewerPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    // plugins.flutter.io/vr_panorama_view
    // flutter_360image_viewer
    let channel = FlutterMethodChannel(name: "flutter.9life.vn/img360viewer", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutter360imageViewerPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    if (call.method == "getPlatformVersion") {
               result("iOS " + UIDevice.current.systemVersion)
    } else if (call.method == "showAlertDialog") {
       DispatchQueue.main.async {
           let alert = UIAlertController(title: "Alert", message: "Hi, My name is flutter", preferredStyle: .alert);
           alert.addAction(UIAlertAction(title: "OK", style: UIAlertActionStyle.default, handler: nil))
           UIApplication.shared.keyWindow?.rootViewController?.present(alert, animated: true, completion: nil);
       }
    } else if call.method == "loadImage"{
       createView(url: call.arguments as! String)
    }
  }
  func createView(url : String){
      _ = VrViewPanoramaController(with : url)
  }
}
