import UIKit
import GVRKit

protocol VrPanoramaViewCOntrollerDelegate : class {
    func imageAlready()
}

final class VrViewPanoramaController : UIViewController,GVRRendererViewControllerDelegate {
    
    fileprivate var vrPanoramaController: GVRRendererViewController?
    var vrRendererView: GVRRendererView?
    
    weak var delegate: VrPanoramaViewCOntrollerDelegate?
    var url : String
    required init?(coder aDecoder: NSCoder) {
        self.url = ""
        super.init(coder: aDecoder)
    }
    
    init(with url:String){
        self.url = url
        super.init(nibName: nil, bundle: nil)
    }
    init(){
        self.url = ""
        super.init(nibName: nil, bundle: nil)
    }
    
    func renderer(for displayMode: GVRDisplayMode) -> GVRRenderer! {
        let image = GVRImageRenderer(contentsOf: URL(fileURLWithPath: self.url))
        image?.setSphericalMeshOfRadius(50, latitudes: 12,
                                       longitudes: 24,
                                       verticalFov: 180,
                                       horizontalFov: 360,
                                       meshType: GVRMeshType.monoscopic)
        let sceneRenderer = GVRSceneRenderer()
        sceneRenderer.renderList.add(image)
        if displayMode == .embedded {
            sceneRenderer.hidesReticle = true
        }
        return sceneRenderer
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated);
        if !url.isEmpty {
            self.vrPanoramaController = GVRRendererViewController()
            self.vrPanoramaController?.delegate = self
            if let vrPanoramaController = vrPanoramaController {
                self.addChildViewController(vrPanoramaController)
                self.view.addSubview(vrPanoramaController.view)
                vrPanoramaController.didMove(toParentViewController: self)
            }
        }
    }
    
    func setUrl(url : String){
        self.url = url
    }
    
    func shouldHideTransitionView() -> Bool {
        return true
    }

}
